Stata 4 Logistic Regression


**#◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘ I ◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘
**#▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬ I ▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬
*=========== I =================================================================

* CHD by phys function
tw 	(function y=0.5/(1+exp(x-7)) +0.5, range(1 15) col(red ))	///
	(function y=0.5/(1+exp(x-6)) +0.5, range(1 15) col(blue))	///
	(function y=0.3/(1+exp(x-6)) +0.7, range(1 15) col(black))	///
	, leg(off) ylabel(0(0.2)1) xline(5 10)
* Beta distributions
tw	(function y=betaden(2,2,x), range(0 1) col(red ))	///
	(function y=betaden(2,4,x), range(0 1) col(blue))	///
	, leg(off)
* Combined
tw	(function y=0.5/(1+exp(x-6)) +0.5	, range(0 15) col(red ))			///
	(function y=1+14*betaden(2,4,x/14)	, range(0 15) col(blue) yaxis(2))	///
	,leg(off) ylabel(0(0.2)1, axis(1)) ytitle("OR: mets→CHD", axis(1)) xtitle("Mets") yscale(off axis(2)) 

* METs metabolic activity, levels 1-15 often converted to average mets-hours per week

* -------------------- Dagitty code ---------------------------------------------------------------
dag {
bb="-10,10,10,-5"
age [pos="0.000,6.000"]
chd [outcome,pos="8.000,0.000"]
educ [pos="0.000,4.000"]
phys [exposure,pos="-8.000,0.000"]
sex [pos="8,4"]
age -> chd
age -> phys
educ -> chd
educ -> phys
phys -> chd
sex -> chd
}



**#◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘ Generate Data ◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘
* Exposure: physical activity (phys) mesured in METS. Outcome: coronary heart disease (chd)(0/1)
* Confounders: age(40-80) and education (low/high)
* Riskfactor for the outcome: sex (males/females)
* Non-linear effect of phys on chd

*▼▬▬▬▬▬▬ Generate Data Start ▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▼
#delimit;																		// set line delimiter to ;
clear; set obs 100000; set seed 12345;											// N=100000;
gen age=runiform(40,80); gen byte sex=rbinomial(1,0.5); gen byte educ=rbinomial(1,0.25);							
gen phys= 9+-0.1*age +2*educ +9*rbeta(2,4);										// Exposure phys;
gen double 	p=ln(0.5/(1+exp(phys-6)) +0.5) +ln(1.2)*age +ln(0.7)*sex +ln(0.6)*educ +rlogistic();	// liability for CHD;
centile p, centile(80); gen byte chd=(p>=r(c_1));								// Outcome  CHD, prevalence 20%;

* Missing;
replace age=. 	if rbinomial(1,0.01);											// 1% missing;
replace phys=. 	if rbinomial(1,0.01);											// 1% missing;

* Binary physical activity (act) and id;
gen act=(phys>7.5) if phys<.;
gen id=_n;

* Labels;
lab var id 		"Id=1-N";	
lab var chd		"Coronary Heart Disease (0/1)";
lab var phys	"Physical activity (mets)";
lab var age		"Age (years)";
lab var educ	"Education, Low/High";
lab var sex		"Sex";
lab var act		"Low/high physical activity";
lab def sex 0"Males" 1"Females"; lab val sex sex;
lab def educ 0"Low" 1"High"; lab val educ educ;
lab def act  0"Low" 1"High"; lab val act  act;


* Drop help variables, order variables;
drop p;
order id phys chd age educ sex;

#delimit cr
*▲▬▬▬▬▬▬ Generate Data End ▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▲


   
**#◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘ Descriptive Analysis ◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘

*▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬ Data and Missing ▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬
* Describe variables and labels
describe									// variables
label list									// value labels

* Missing
misstable sum phys act chd age educ sex, all			/* table of missing */

* Keep the analysis sample constant over models:
* Generate sample from fully adjusted model
logistic chd phys age educ sex													// full model
generate complete=e(sample)														// generate a sample indicator for "complete case"
tab complete
* Analyse all model restricted to this sample
logistic chd phys if complete													// or "if complete==1"
* or run: 
* keep if complete==1

*▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬ Uni- and bi-variate analysis ▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬
* Outcome and (binary) exposure
tab chd																			// outcome
sum phys																		// continous exposure
kdensity phys
tab act																			// binary exposure
tab act chd, row chi nofreq														/* table with chi-square test of independence - H0 incorrect*/
cc chd act																		/* OR (cc=case control) */
logistic chd act																// same OR
cs chd act																		/* RD and RR (cs=cohort study) */

local OBS "may skip"
* Scatterplots CHD by activity
tw	(scatter chd phys) (lpolyci chd phys), leg(off) ytitle("CHD") xtitle("Physical activity, Mets") name("scatter", replace)	// fpfit does not work so well here

* More advanced spikeplot (rspike), CHD by activity
cap drop y
gen y=chd-0.02																	/* 0.02 is the length of the spikes */
tw	(rspike y chd phys, lwidth(*0.1) ) (lpolyci chd phys)						///
	,ytitle("CHD") xtitle("Physical activity") leg(off) scale(1.3) name("spike", replace)

* Continue the bi-variate analysis with chd versus each potential confounder (or covariate) ...

local OBS "Go to Example"

*▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬ Logistic Regression, Interpretations ▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬
* Binary exposure "act"
tab act					// binary exposure
lab list act			// coded 0=Low, 1=High
logistic chd act		// with a binary exposure we do not need the i.act notation. Get the effect of one unit increase in act
logistic chd i.act		// the i.act notation makes it clear that we get the OR for High (versus Low) activity
logistic chd ib0.act	// act=0 as the basline (reference) category. This is the default
logistic chd ib1.act	// act=1 as the basline (reference) category. This gived the OR for Low versus High activity

* Continuous exposure "phys"
sum phys				// phys is measured in METS ranging from 1 (inactive) to 15 (very active)
logistic chd phys		// continuous exposure. Get the effect of one unit increase in phys 
* Using a continuous exposure gives better precision, but assumes a linear effect (on the log ods scale) in the standard model



**#◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘ Regression Analysis ◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘
*▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬ Logistic Regression, standard model ▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬
* Unadjusted and Adjusted model keeping N the same
logistic chd phys					if complete									// Model 1, crude effect
est store m1																	// save estimates as "m1"
* Conclusion: phys ranges from 1-15 mets. For enery unit increase in phys, the odds of CHD decreases with a factor 0.60.
logistic chd phys age i.educ		if complete									// adjusted effect
estimates store m2																
logistic chd phys age i.educ sex	if complete									// sex spesific effect
estimates store full																
* Compare estimates
estimates table m1 m2 full, eform keep(phys) b(%8.2f) stats(N)					/* eform gives OR's, 8 places and 2 decimals fixed format */
estimates table m1 m2 full, eform keep(phys) b(%8.4f) se(%8.5f)					/* same point estimates, same se when adding sex. In theory both could be a little different */
* Adjusting for a risk factor for the outcome in a logistic model moves the estimate a little bit away from 1
*	The confidence intervall increases a little bit, but the combined effect is to move the closest part of the CI away form 1, increasing the "power"
 

local OBS "Go to Assumptions"

*▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬ Assumptions of the standard model ▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬
* Three assumptions: 
* 	1) Independent residuals
* 	2) Linear effects risk factors (on the log-odds scale)
* 	3) No interactions
* No test of constant variance is needed, the logistic model is heteroscedastic

* ========== Independent Residuals =============================================
* When will CHD of one person depend on the CHD of another?
* 	If they are siblings.
* If many siblings in the data: 
*	use logistic ..., vce(cluster(motherID))
* 	or use logistic mixed models: melogit ...

local OBS "Go to Presentation"

* ==========  Non-Linear effect ================================================
*  We will test the linear effect of physical activity. Will add splines to the model
* Use spline (cubic spline)
cap drop physI
gen physI=int(phys)																/* integer phys for plotting */
tab physI
cap drop cs?																	// drop if present
mkspline cs=phys, cubic nknots(4) display										// cubic spline in phys, will generate cs1, cs2, cs3 (refer as cs?)
logistic chd cs? age i.educ sex if complete										/* model with cubic spline */
est store cubic	
est stats full cubic															// comparing fit using AIC, cubic better
lrtest full cubic																// testing the fit with likelihood ratio test, cubic different from full, cubic better
qui margins, over(physI) at(age=60 educ=0 sex=0) predict(xb) 					/* expected values over physI at fixed values of the other covariates. predict(xb) means linear predictor */
marginsplot, xlines(3.0989   5.549518   7.261149   10.23472) xlines(4 8, lcol(gs10))	// plot with knot values pasted in
marginsplot, xlines(4 8, lcol(gs10))													// plot with new knot values for linear spline
* Conclusion:  	Significant deviation from linearity (on the log odds scale) for the effect of phys on CHD.

* New model with linear spline in age, knots at 3 and 9 (based on the cubic spline plot)
cap drop l1 l2 l3
mkspline l1 4 l2 8 l3 = phys													/* linear spline with a knot at 3 and 9 mets */
logistic chd l? age i.educ sex if complete										/* model with linear spline for phys */
est store linspl
mat R=r(table)																	// list result matrix
global or1: display %5.2f R[1,1]												// store OR for later use
global or2: display %5.2f R[1,2]
global or3: display %5.2f R[1,3]

* Compare model estimates and fits
est table full linspl, eform keep(phys l1 l2 l3) b(%8.2f) star stats(N)			/* estimates */
est stats full cubic linspl														/* fits */
* Conclusion: (AIC) Model cubic is best, then linear spline and last the full model. 
* Of the spline models, the linear spline model is easier to interpret.

* Plot of results on the probability scale
quietly margins, over(physI) at(age=60 educ=0 sex=0)							// expected values over phys on the probability scale (no predict(xb))
marginsplot, xlines(4 8, lcol(gs10)) text(0.08 2 "OR=$or1"  0.08 5.5 "OR=$or2" 0.08 12 "OR=$or3", col(red) size(*1.3) box bcol(white))	///
	title("Predicted CHD risk by physial activity") ytitle("Probability of CHD") xtitle("Physical avtivity (mets)") ylabel(0(0.02)0.12)

	
local OBS "Go to Interaction"


* ========== Interaction =======================================================
* Is the effect of phys on chd the same for low and high education? (continuous*categorical). We could also have used the linear spline in the interaction (see below)
logistic chd c.phys##i.educ c.age sex	if complete								/* Interaction model  */
* Conclusion: no phys-educ interaction, will continue anyway
tab educ, nolab																	// show coding of educ
logistic, coeflegend															// show internal names
lincom _b[phys] + 0*_b[1.educ#c.phys], or										// effect of phys on chd for educ=0. This form calulates the CI on the log-odds scale.
lincom _b[phys] + 1*_b[1.educ#c.phys], or										// effect of phys on chd for educ=1

* Easier alternative, but this works only when the modifying variable is categorical (see Paul Dickman homepage)
logistic chd c.age c.phys#i.educ i.educ sex	if complete							/* Interaction model  */
* This shows the ORs for each level of physical activity for Low and High education directly 

* Is the effect of phys on chd the same for all ages? (continuous*continuous)
logistic chd c.phys##c.age i.educ sex	if complete								/* Interaction model  */
* Conclusion: significant (or borderline) phys-age interaction
* Effects of phys equation: b(phys)+age*b(phys*age), this gives effects for each age, will show two: one for age=40 and one for age=80
sum age																			/* age range */
logistic, coeflegend															// show internal names
lincom _b[phys] + 40*_b[c.age#c.phys], or										// effect of phys on chd for age=40
lincom _b[phys] + 80*_b[c.age#c.phys], or										// effect of phys on chd for age=80

* Is the effect of phys on chd the same for all ages? (splines*continuous)
logistic chd c.(l1 l2 l3)##c.age i.educ	sex if complete							/* Interaction model  */
* Conclusion: no spline(phys)-age interaction, will continue anyway
sum age																			/* age range */
logistic, coeflegend															// show internal names
lincom _b[l1]+40*_b[c.l1#c.age], or												// OR spline1, age=40
lincom _b[l1]+80*_b[c.l1#c.age], or												// OR spline1, age=80
lincom _b[l2]+40*_b[c.l2#c.age], or												// OR spline2, age=40
lincom _b[l2]+80*_b[c.l2#c.age], or												// OR spline2, age=80
lincom _b[l3]+40*_b[c.l3#c.age], or												// OR spline3, age=40
lincom _b[l3]+80*_b[c.l3#c.age], or												// OR spline3, age=80
* See "Some Margins examples" below for an easier descriptions of splines with interactions


local OBS "Go to Influence"

*▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬ Influence ▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬
* We will look at influence measures to see if the results are robust against outliers

* Influence statistics for the linear spline(phys) model: delta-beta (one measure for each observation, but common to all covariates)				
logistic chd l? age i.educ sex if complete										// linear spline(phys), best model so far
cap drop dBeta p																/* drop if already present */
predict p																		/* predict probability (default) of the outcome into new variable p */
predict dBeta, db																/* delta beta (one value per observation, not one per estimate) into new variable dBeta */
tw 	(sc dBeta p, msize(*0.5) jitter(10))										/// scatter delta-beta by probability of outcome
	(sc dBeta p if dBeta>0.1, col(red) mlab(id) jitter(10))						/// delta-beta with values>0.1 shown in red
	, leg(off) scale(1.3)
list id dBeta chd phys age if dBeta>0.1 & dBeta!=.								/* list obs with high delta-beta using a cutoff=0.1. There is no universal cutoff for logistic delta-beta, see two examples below  */
* Conclusion: no outliers with high influence, otherwise:
logistic chd l? age i.educ sex if complete & dBeta<0.1							// model with outlier removed
est store removed
est table linear removed, keep(l1 l2 l3) b(%5.2f) star stats(N)	eform			// compare exposure estimates

* ========== Two examples of delta-beta plots ==================================
* There is no universal cutoff for delta-betas from logistic regression. Small dataset will have much larger delta-beta values!

* Ex 1: Points (observations) that are separeted from the rest in the delta-beta plot are potetial outliers:
tw 	(sc dBeta p if dBeta<0.005 | dBeta>0.012, msize(*0.5) jitter(10))	///
	(pcarrowi .014 .4 .014 .1 "Potential outliers") (pcarrowi .01 .4 .01 .1 "Gap"), leg(off)
* Ex 2: When no points (observations) are separeted from the rest (no gaps) in the delta-beta plot, there are no potetial outliers: 
tw 	(sc dBeta p if dBeta<0.01 , msize(*0.5) jitter(10))	///
	(pcarrowi  .007 .5 .007 .3   .007 .5 .008 .3    .007 .5 .006 .3 "No clear Gaps")	///
	,text(.006 .6  "No potential outliers") leg(off)



*▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬ Final Model ▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬
* Final model
logistic chd l? age i.educ sex if complete										// linear spline in phys model
est store final

* Plot if the final model
* Since there were no interactions and no outliers with high influence, the final model is as we have seen before
logistic chd l? age i.educ sex if complete										/* model with linear spline for phys */
mat R=r(table)
global or1: display %5.2f R[1,1]												// store OR for later use
global or2: display %5.2f R[1,2]
global or3: display %5.2f R[1,3]
* Plot of results on the probability scale
quietly margins, over(physI) at(age=60 educ=0 sex=0)							// expected values over phys on the probability scale (no predict(xb))
marginsplot, xlines(4 8, lcol(gs10)) text(0.08 2 "OR=$or1"  0.08 5.5 "OR=$or2" 0.08 12 "OR=$or3", col(red) size(*1.3) box bcol(white))	///
	title("Predicted CHD risk by physial activity") ytitle("Probability of CHD") xtitle("Physical avtivity (mets)") ylabel(0(0.02)0.12)

local OBS "Go to Margins"


* ============ Margins (for the non-spline model) ==============================
* It is often helpful to predict the probability of the outcome over exposure.
* By using "margins" you let Stata do the difficult work of handling interactions and non-linearities
* All "margins" commands can be followed by "marginsplot"

* Non-spline model
logistic chd phys age i.educ sex if complete

* Margins by itself gives the overall predicted probability of the outcome
margins

* Marginsplot of probability of CHD by physical activity
margins, at(phys=(1(1)15))
marginsplot																		// linear on the log-odds scale, almost linear on the prob scale

* Marginsplot of probability of CHD by physical activity by education
margins educ, at(phys=(1(1)15))
marginsplot																		// parallel lines on the log-odds scale, almost parallel on the prob scale

* Marginsplot of probability of CHD by physical activity by age
margins, at(phys=(1(1)15) age=(60 80))
marginsplot

* Probability of CHD standardized to the population values og age and sex, for fixed vales of physical activity and education
margins, at(phys=5 educ=1)														// standardized on variables in the model that are not included here 




*▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬ Some Margins examples ▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬
* Margins and marginsplot of predicted probabilities of the outcome
* Use the i. operator for categorical (factor) variables.
* Use the # and ## operators for interactions.
* Use the c. for continuous variables involved in an interaction.
* Predict on the probability scale (the default for logistic regression)

* Model with spline and interaction
cap drop cs?
mkspline cs=age, cubic nk(4)
logistic chd c.phys##c.cs? i.educ sex	if complete					/* Interaction and spline: phys*S(age) */

* Some margins commands
margins																/* probability of CHD=20% */
margins educ														/* probability of CHD=21% and 16%  for low and high education resp. Works only for categorical vars */
margins, at(sex=(0 1))												// works for both cont and cat vars.
margins, at(phys=(3 6 9 12))										// probability of CHD= 23%, 19%, 16% and 13% for mets=3, 6, 9 and 12
* All estimates are marginal over variables not set in at-statements

* ============ Marginsplots based on the model above ===========================
* Probability of CHD by age for low and high phys
gen ageI=round(age)																// integer values of age
qui margins, at(phys=(1 15)) over(ageI)											// prob of outcome by phys for two ages
marginsplot, xdim(ageI) 														/// x-dimension=age
	title("Predicted probability of CHD by age") 								///
	subtitle("for low and high physical activity") 								///
	legend(ring(0) pos(11) col(1))												/// legend inside plot at clock position 11 in one row
	ytitle("Predicted Pr(CHD)") xtitle("Age")

* Probability of CHD by phys for low and high age
cap drop ageI
gen ageI=(age>60)																// high/low age
qui margins, at(phys=(1(1)15)) over(ageI)										// prob of outcome by phys for two ages
marginsplot, xdim(phys) 														/// x-dimension=phys
	title("Predicted probability of CHD by physical activity") 					///
	subtitle("for low and high age") 											///
	legend(off) text(.46 3 "Age>60"   .06 3 "Age<=60")							/// legend off, text explaining curves
	ytitle("Predicted Pr(CHD)") xtitle("Physical activity (mets)")

	
local OBS "Go to Summing up"	
	
	
* Marginsplots, spline models
qui logistic chd l? c.age i.educ	if complete									// linear spline(phys), final model
qui margins, over(physI) at(age=(60 80))										// prob of outcome by phys for two ages
marginsplot, xdim(physI)														// plot by physI

* Marginsplots with shadow CI
marginsplot, xdim(physI) recastci(rarea)										// plot by physI, shaded confidence intervals

* For more control over the plot: save the r(table) matrix and plot from this
qui logistic chd phys age i.educ	if complete									
margins, at(phys=(1(1)15))
mat R=r(table)'																	// transposed result table from margins
mat A=r(at)																		// matrix of at-values
mat list R																		// list matrix
mat list A
svmat R, names(col)																// save matrix, names by column names (b, ..., ll, ul,...)
svmat A, names(y)																// save matrix, names =y1, y2, ...
tw 	(rarea ll ul y1, col(gs10%50))(line b y1, col(black))						/// areaplot (grayscale-10 with 50% transparency) with line
	, leg(off) ytitle("Pr(outcome)") xtitle("Exposure")
	
* Effect plot
qui logistic chd c.phys##c.age i.educ	if complete								/* Interaction model */
qui margins, dydx(phys) at(age=(40(1)80))										// effect on the pr(CHD) of one unit increase in phys by age 
marginsplot



local OBS "Go to Summing up"



**#◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘ Result Tables, Stata 17 ◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘
**#▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬ Table 1 ▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬
* Sample
keep if complete

* Generate categorical variables from continous
tab act
label list
sum age
gen age2=(age>=60)
label values age2 educ
tab age2

* Count and Mean of outcome by covariates
collect clear
collect create tab1																// create tab1
table act, 	statistic(count chd) statistic(mean chd) nototal append name(tab1)	// append N and mean
table age2, statistic(count chd) statistic(mean chd) nototal append name(tab1)
table educ, statistic(count chd) statistic(mean chd) nototal append name(tab1)
table sex, 	statistic(count chd) statistic(mean chd) nototal append name(tab1)
collect dims																	// show dimensions to use in layout
collect layout (act age2 educ sex)(result)										// table of variables by results

* Add inn OR RR, RD and p at the second level of the variables (coded 1)
* ORs
*collect r(or), tag(act[1])		: cc chd act									// if OR are added the p-values fall out. ??
*collect r(or), tag(age2[1])	: cc chd age2
*collect r(or), tag(educ[1])	: cc chd educ
*collect r(or), tag(sex[1])		: cc chd sex
* RR, RD and p
collect r(rr) r(rd) r(p), tag(act[1])	: cs chd act
collect r(rr) r(rd) r(p), tag(age2[1])	: cs chd age2
collect r(rr) r(rd) r(p), tag(educ[1])	: cs chd educ
collect r(rr) r(rd) r(p), tag(sex[1])	: cs chd sex
collect label list result, all
collect layout (act age2 educ sex)(result[count mean or rr rd p])				// specify results

* Add overall count and mean
table, statistic(count chd) statistic(mean chd) nototal append name(tab1)		// overall count and mean
collect dims																	// show dimensions to use in layout
collect label list cmdset, all													// overall is cmdset 5
collect layout (cmdset[5] act age2 educ sex)(result[count mean or rr rd p])		// overall count and mean first

* Modify table
collect label list result
collect label levels result count "N" mean "Prop." or "OR" rr "RR" rd "RD" p "p-value", modify	// modify labels
collect label levels cmdset 5 "All"												// label cmdset 5 "All"
collect style header cmdset, title(hide)										// hide cmdset header
collect style cell result[mean or rr rd], nformat(%6.2f)						// 2 decimals
collect style cell result[p], nformat(%6.3f)									// 3 decimals for p-values
collect style cell border_block, border(right, pattern(nil))					// remove vertical border			
collect label dim act "Physical activity", modify								// change dimension label
collect label dim age2 "Age", modify
collect label dim educ "Education", modify
collect preview

* Export to Word
cd "C:\Users\hest\Documents\Courses\Regular courses\Stata course UiO"
collect style putdocx, layout(autofitcontents)    title("Table 1: Proportion CHD by covariates")
collect export "Logistic Regression Table 1.docx", as(docx) replace


**#▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬ Table 2 ▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬
* Table of regression results
* Sample
keep if complete

* Crude model
collect clear
collect style autolevels result, clear
collect: logistic chd phys

* Adjusted model
collect: logistic chd phys age i.educ sex

* Linear spline model
collect: logistic chd l1 l2 l3 age i.educ sex

* Table of regression commands
collect label levels cmdset 1 "Model 1: Unadjusted" 2 "Model 2: Adjusted" 3 "Model 3: Linear spline" , modify		// label for cmdset
collect label levels result cmdline "Regression command", modify
collect layout (cmdset) (result[cmdline])
collect style cell cell_type[item column], halign(left)
collect style cell cell_type[item column-header], halign(left)
collect preview

* Export to Word
cd "C:\Users\hest\Documents\Courses\Regular courses\Stata course UiO"
collect style putdocx, layout(autofitcontents)    title("Table 2a: Regression models")
collect export "Logistic Regression Table 2a.docx", as(docx) replace

* Table of regression results
collect layout (cmdset#colname[phys l1 l2 l3]) (result[_r_b _r_ci])
collect label list result
collect label levels result _r_b "OR", modify
collect style cell result[_r_ci],sformat("(%s)") cidelimiter(,)	
collect style cell result[_r_ci], nformat(%4.2f) 
collect style cell result[_r_b], nformat(%6.2f) 
collect label levels colname l1 "Below 3 mets" l2 "Between 3 and 9 mets " l3 "Above 9 mets", modify		// label for colnames
collect style cell cell_type[item column-header], halign(center)
collect style cell cell_type[item column], halign(center)
collect preview

* Export to Word
cd "C:\Users\hest\Documents\Courses\Regular courses\Stata course UiO"
collect style putdocx, layout(autofitcontents)    title("Table 2: OR for one mets increase of physical activity on CHD")
collect export "Logistic Regression Table 2.docx", as(docx) replace

















**#◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘ Binary outcome, OR, RR or RD effect measures ◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘
* Run the simulations line 42-74 to generate the data

*▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬ 3 ways of obtaining OR, RR and RD ▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬▬
* Crude OR, RR or RD results from Epi-tables ("cc" and "cs")
cc chd act																		/* OR 			(cc=case control) */
cs chd act																		/* RD and RR 	(cs=cohort study) */

* Crude binary regression models that give either OR or RR or RD as effect measures
binreg chd act, or															/* OR as effect measure */
binreg chd act, rr															/* RR as effect measure */
binreg chd act, rd															/* RD as effect measure */
* Conclusion: these models give the same result as the "cc" and "cs" tables above

* More numerically stable regression models that give either OR or RR or RD as effect measures
logistic chd act																/* OR as effect measure */
poisson  chd act, robust irr													/* RR as effect measure */
regress  chd act, robust														/* RD as effect measure */

* Conclusions: the Epi-tables, the binreg models and the more stable counterparts all give (appr.) the same results
* The binreg and more stable counterparts can all be adjusted for confounders (and selection variables)
* We are therefore free to tell the story in terms of OR, RR or RD
* OR and RR are similar for rare outcomes, but RR is easier to interpret for more common outcomes (>10%)
* Telling the story in terms of RD means using the original data scale (either prevalence or incidence proportions, good!) 
*	and is easy to understand, it evaluates interaction on the additive scale (good!),
* 	but may give many negative predictions for rare outcomes (unclear if this is a large problem!)
* Reference: Hellevik,O. Linear versus logistic regression when the dependent variable is a dichotomy, 2007

* RD example
tab chd																			// 20% chd
regress  chd phys age educ, robust												/* RD as effect measure */
predict p
sum p
gen neg=(p<0) if p<.
tab neg															
* Conclusion: 	about 10.9 pp (percentage points) less CHD per METS of phys. 
* 				About 4.7 pp less CHD among high educated
* 				23% predicted negative probabilities, this is a bit disturbing! See also the plot "Scatterplots CHD by activity" line 115
* 				





**#◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘ I ◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘◘


* ----------------------------------------------------------------------------------------------------------------------------------------------------
* <<<<<<<<<<<<<<<<<<<<<<<<<< Logistic model and assumptions >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
* ----------------------------------------------------------------------------------------------------------------------------------------------------
* Model (inverse link) and data 
clear
set obs 300
gen age=runiform(0, 10)
gen d=rbinomial(1,0.1*age)
gen y=cond(d,1.02,-0.02)
tw	(rspike y d age, lwidth(*0.5))(function y=1/(1+exp(5-x)), 	///
	range(0 10) lwidth(*1.5)), leg(off) xtitle("Exposure") ytitle("Disease") ylabel(0 1) scale(1.3)

Define:
  p=E(y|x), y|x-binomial
Model:
  log(p/(1-p))=b0+b1x1+b2x2
Association or effect measure:
  OR1=exp(b1)
